Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkHexahedron Class Reference

`#include <vtkHexahedron.h>`

Inheritance diagram for vtkHexahedron:

[legend]
Collaboration diagram for vtkHexahedron:

[legend]
List of all members.

## Detailed Description

a cell that represents a linear 3D hexahedron

Date:
  2002/12/26 18:24:21

Revision:
  1.65

vtkHexahedron is a concrete implementation of vtkCell to represent a linear, 3D rectangular hexahedron (e.g., "brick" topology). vtkHexahedron uses the standard isoparametric shape functions for a linear hexahedron. The hexahedron is defined by the eight points (0-7) where (0,1,2,3) is the base of the hexahedron which, using the right hand rule, forms a quadrilaterial whose normal points in the direction of the opposite face (4,5,6,7).

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (68%)
  - Miller, Jim (6%)
  - Geveci, Berk (6%)
  - Law, Charles (5%)

CVS logs (CVSweb):
  - .`h` (`/Common/vtkHexahedron.h)`
  - .`cxx` (`/Common/vtkHexahedron.cxx)`

Examples:
  vtkHexahedron (Examples)

Tests:
  vtkHexahedron (Tests)

Definition at line 58 of file vtkHexahedron.h.

## Public Types
typedef vtkCell3D | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
int | EvaluatePosition (float x[3], float *closestPoint, int &subId, float pcoords[3], float &dist2, float *weights)
void | EvaluateLocation (int &subId, float pcoords[3], float x[3], float *weights)
int | IntersectWithLine (float p1[3], float p2[3], float tol, float &t, float x[3], float pcoords[3], int &subId)
int | Triangulate (int index, vtkIdList *ptIds, vtkPoints *pts)
void | Derivatives (int subId, float pcoords[3], float *values, int dim, float *derivs)
void | JacobianInverse (float pcoords[3], double **inverse, float derivs[24])
virtual void | GetEdgePoints (int edgeId, int *&pts)
virtual void | GetFacePoints (int faceId, int *&pts)
virtual float * | GetParametricCoords ()
int | GetCellType ()
int | GetNumberOfEdges ()
int | GetNumberOfFaces ()
vtkCell * | GetEdge (int edgeId)
vtkCell * | GetFace (int faceId)
int | CellBoundary (int subId, float pcoords[3], vtkIdList *pts)
void | Contour (float value, vtkDataArray *cellScalars, vtkPointLocator *locator, vtkCellArray *verts, vtkCellArray *lines, vtkCellArray *polys, vtkPointData *inPd, vtkPointData *outPd, vtkCellData *inCd, vtkIdType cellId, vtkCellData *outCd)
## Static Public Methods
vtkHexahedron * | New ()
int | IsTypeOf (const char *type)
vtkHexahedron * | SafeDownCast (vtkObject *o)
void | InterpolationFunctions (float pcoords[3], float weights[8])
void | InterpolationDerivs (float pcoords[3], float derivs[24])
int * | GetEdgeArray (int edgeId)
int * | GetFaceArray (int faceId)
## Protected Methods
| vtkHexahedron ()
| ~vtkHexahedron ()
## Protected Attributes
vtkLine * | Line
vtkQuad * | Quad

## Member Typedef Documentation

typedef vtkCell3D vtkHexahedron::Superclass

| Reimplemented from vtkCell3D. Definition at line 62 of file vtkHexahedron.h.

## Constructor & Destructor Documentation

vtkHexahedron::vtkHexahedron | ( |  | ) | `[protected]`

vtkHexahedron::~vtkHexahedron | ( |  | ) | `[protected]`

## Member Function Documentation

vtkHexahedron* vtkHexahedron::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkHexahedron::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkCell3D.

int vtkHexahedron::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkCell3D.

virtual int vtkHexahedron::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkCell3D.

vtkHexahedron* vtkHexahedron::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkCell3D.

virtual void vtkHexahedron::GetEdgePoints | ( | int | edgeId,
|  | int *& | pts
| ) | `[virtual]`

| See vtkCell3D API for description of these methods. Implements vtkCell3D.

virtual void vtkHexahedron::GetFacePoints | ( | int | faceId,
|  | int *& | pts
| ) | `[virtual]`

| See vtkCell3D API for description of these methods. Implements vtkCell3D.

virtual float* vtkHexahedron::GetParametricCoords | ( |  | ) | `[virtual]`

| See vtkCell3D API for description of these methods. Reimplemented from vtkCell3D.

int vtkHexahedron::GetCellType | ( |  | ) | `[inline, virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell. Definition at line 73 of file vtkHexahedron.h. References VTK_HEXAHEDRON.

int vtkHexahedron::GetNumberOfEdges | ( |  | ) | `[inline, virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell. Definition at line 74 of file vtkHexahedron.h.

int vtkHexahedron::GetNumberOfFaces | ( |  | ) | `[inline, virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell. Definition at line 75 of file vtkHexahedron.h.

vtkCell* vtkHexahedron::GetEdge | ( | int | edgeId | ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

vtkCell* vtkHexahedron::GetFace | ( | int | faceId | ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

int vtkHexahedron::CellBoundary | ( | int | subId,
|  | float | pcoords[3],
|  | vtkIdList * | pts
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

void vtkHexahedron::Contour | ( | float | value,
|  | vtkDataArray * | cellScalars,
|  | vtkPointLocator * | locator,
|  | vtkCellArray * | verts,
|  | vtkCellArray * | lines,
|  | vtkCellArray * | polys,
|  | vtkPointData * | inPd,
|  | vtkPointData * | outPd,
|  | vtkCellData * | inCd,
|  | vtkIdType | cellId,
|  | vtkCellData * | outCd
| ) | `[virtual]`

| See the vtkCell API for descriptions of these methods. Implements vtkCell.

int vtkHexahedron::EvaluatePosition | ( | float | x[3],
|  | float * | closestPoint,
|  | int & | subId,
|  | float | pcoords[3],
|  | float & | dist2,
|  | float * | weights
| ) | `[virtual]`

| Given a point x[3] return inside(=1) or outside(=0) cell; evaluate parametric coordinates, sub-cell id (!=0 only if cell is composite), distance squared of point x[3] to cell (in particular, the sub-cell indicated), closest point on cell to x[3] (unless closestPoint is null, in which case, the closest point and dist2 are not found), and interpolation weights in cell. (The number of weights is equal to the number of points defining the cell). Note: on rare occasions a -1 is returned from the method. This means that numerical error has occurred and all data returned from this method should be ignored. Also, inside/outside is determine parametrically. That is, a point is inside if it satisfies parametric limits. This can cause problems for cells of topological dimension 2 or less, since a point in 3D can project onto the cell within parametric limits but be "far" from the cell. Thus the value dist2 may be checked to determine true in/out. Implements vtkCell.

void vtkHexahedron::EvaluateLocation | ( | int & | subId,
|  | float | pcoords[3],
|  | float | x[3],
|  | float * | weights
| ) | `[virtual]`

| Determine global coordinate (x[3]) from subId and parametric coordinates. Also returns interpolation weights. (The number of weights is equal to the number of points in the cell.) Implements vtkCell.

int vtkHexahedron::IntersectWithLine | ( | float | p1[3],
|  | float | p2[3],
|  | float | tol,
|  | float & | t,
|  | float | x[3],
|  | float | pcoords[3],
|  | int & | subId
| ) | `[virtual]`

| Intersect with a ray. Return parametric coordinates (both line and cell) and global intersection coordinates, given ray definition and tolerance. The method returns non-zero value if intersection occurs. Implements vtkCell.

int vtkHexahedron::Triangulate | ( | int | index,
|  | vtkIdList * | ptIds,
|  | vtkPoints * | pts
| ) | `[virtual]`

| Generate simplices of proper dimension. If cell is 3D, tetrahedron are generated; if 2D triangles; if 1D lines; if 0D points. The form of the output is a sequence of points, each n+1 points (where n is topological cell dimension) defining a simplex. The index is a parameter that controls which triangulation to use (if more than one is possible). If numerical degeneracy encountered, 0 is returned, otherwise 1 is returned. Implements vtkCell.

void vtkHexahedron::Derivatives | ( | int | subId,
|  | float | pcoords[3],
|  | float * | values,
|  | int | dim,
|  | float * | derivs
| ) | `[virtual]`

| Compute derivatives given cell subId and parametric coordinates. The values array is a series of data value(s) at the cell points. There is a one-to-one correspondence between cell point and data value(s). Dim is the number of data values per cell point. Derivs are derivatives in the x-y-z coordinate directions for each data value. Thus, if computing derivatives for a scalar function in a hexahedron, dim=1, 8 values are supplied, and 3 deriv values are returned (i.e., derivatives in x-y-z directions). On the other hand, if computing derivatives of velocity (vx,vy,vz) dim=3, 24 values are supplied ((vx,vy,vz)1, (vx,vy,vz)2, ....()8), and 9 deriv values are returned ((d(vx)/dx),(d(vx)/dy),(d(vx)/dz), (d(vy)/dx),(d(vy)/dy), (d(vy)/dz), (d(vz)/dx),(d(vz)/dy),(d(vz)/dz)). Implements vtkCell.

void vtkHexahedron::InterpolationFunctions | ( | float | pcoords[3],
|  | float | weights[8]
| ) | `[static]`

| Hexahedron specific

void vtkHexahedron::InterpolationDerivs | ( | float | pcoords[3],
|  | float | derivs[24]
| ) | `[static]`

| Hexahedron specific

int* vtkHexahedron::GetEdgeArray | ( | int | edgeId | ) | `[static]`

| Hexahedron specific

int* vtkHexahedron::GetFaceArray | ( | int | faceId | ) | `[static]`

| Hexahedron specific

void vtkHexahedron::JacobianInverse | ( | float | pcoords[3],
|  | double ** | inverse,
|  | float | derivs[24]
| ) |

| Given parametric coordinates compute inverse Jacobian transformation matrix. Returns 9 elements of 3x3 inverse Jacobian plus interpolation function derivatives.

## Member Data Documentation

vtkLine* vtkHexahedron::Line`[protected]`

| Definition at line 114 of file vtkHexahedron.h.

vtkQuad* vtkHexahedron::Quad`[protected]`

| Definition at line 115 of file vtkHexahedron.h.

The documentation for this class was generated from the following file:

- Common/vtkHexahedron.h